diff -purN u-boot/board/integratorcp/flash.c u-boot-integratorcp-flash/board/integratorcp/flash.c
--- u-boot/board/integratorcp/flash.c	Wed Jan 12 11:16:22 2005
+++ u-boot-integratorcp-flash/board/integratorcp/flash.c	Wed Jan 12 11:31:32 2005
@@ -309,7 +309,7 @@ void flash_unprotect_sectors (FPWV * add
 	reset_timer_masked();
 	while (((status = *addr) & (FPW)0x00800080) != 0x00800080) {
 		if (get_timer_masked() > CFG_FLASH_ERASE_TOUT) {
-			printf("Timeout");
+			printf("Unprotect Timeout");
 			break;
 		}
 	}
@@ -332,14 +332,14 @@ int flash_erase (flash_info_t * info, in
 		} else {
 			printf ("- no sectors to erase\n");
 		}
-		return 1;
+		return ERR_UNKNOWN_FLASH_TYPE;
 	}
 
 	type = (info->flash_id & FLASH_VENDMASK);
 	if ((type != FLASH_MAN_INTEL)) {
 		printf ("Can't erase unknown flash type %08lx - aborted\n",
 				info->flash_id);
-		return 1;
+		return ERR_UNKNOWN_FLASH_VENDOR;
 	}
 
 	prot = 0;
@@ -377,8 +377,6 @@ int flash_erase (flash_info_t * info, in
 			*addr = (FPW) 0x00D000D0; /* erase confirm */
 			mb();
 
-			udelay(1000); /* Let's wait 1 ms */
-
 			/* re-enable interrupts if necessary */
 			if (flag)
 				enable_interrupts();
@@ -395,12 +393,12 @@ int flash_erase (flash_info_t * info, in
 #ifdef DEBUG
 						printf ("Timeout,0x%08x\n", status);
 #else
-						printf("Timeout\n");
+						printf("Erase Timeout\n");
 #endif
 
 						*addr = (FPW) 0x00500050;
 						*addr = (FPW) 0x00FF00FF; /* reset to read mode */
-						rcode = 1;
+						rcode = ERR_TIMOUT;
 						break;
 					}
 				}
@@ -428,7 +426,7 @@ int write_buff (flash_info_t * info, uch
 	int count, i, l, rc, port_width;
 
 	if (info->flash_id == FLASH_UNKNOWN) {
-		return 4;
+		return ERR_UNKNOWN_FLASH_TYPE;
 	}
 /* get lower word aligned address */
 #ifdef FLASH_PORT_WIDTH16
@@ -483,7 +481,7 @@ int write_buff (flash_info_t * info, uch
 	}
 
 	if (cnt == 0) {
-		return (0);
+		return (ERR_OK);
 	}
 
 	/*
@@ -546,12 +544,13 @@ static int write_data (flash_info_t * in
 #endif
 			*addr = (FPW) 0x00500050; /* clear status register cmd */
 			*addr = (FPW) 0x00FF00FF; /* restore read mode */
-			return (1);
+			printf("Write Timeout");
+			return (ERR_TIMOUT);
 		}
 	}
 
 	*addr = (FPW) 0x00FF00FF; /* restore read mode */
-	return (0);
+	return (ERR_OK);
 }
 
 void inline spin_wheel (void)
diff -purN u-boot/cpu/arm926ejs/interrupts.c u-boot-integratorcp-flash/cpu/arm926ejs/interrupts.c
--- u-boot/cpu/arm926ejs/interrupts.c	Fri Jan  7 16:00:38 2005
+++ u-boot-integratorcp-flash/cpu/arm926ejs/interrupts.c	Wed Jan 12 11:33:24 2005
@@ -204,8 +204,8 @@ int interrupt_init (void)
 #ifdef CONFIG_INTEGRATOR
 	/* Load timer with initial value */
 	*(volatile ulong *)(CFG_TIMERBASE + 0) = TIMER_LOAD_VAL;
-	/* Set timer to be enabled, free-running, no interrupts, 256 divider */
-	*(volatile ulong *)(CFG_TIMERBASE + 8) = 0x8C;
+	/* Set timer to be enabled, free-running, no interrupts, 256 divider - See Integrator User Guide */
+	*(volatile ulong *)(CFG_TIMERBASE + 8) = 0x8A;
 #endif	/* CONFIG_INTEGRATOR */
 #ifdef CONFIG_VERSATILE
 	*(volatile ulong *)(CFG_TIMERBASE + 0) = CFG_TIMER_RELOAD;	/* TimerLoad */
@@ -275,7 +275,7 @@ ulong get_timer_masked (void)
 
 	if (lastdec >= now) {		/* normal mode (non roll) */
 		/* normal mode */
-		timestamp += lastdec - now; /* move stamp fordward with absoulte diff ticks */
+		timestamp += lastdec - now; /* move stamp forward with absolute diff ticks */
 	} else {			/* we have overflow of the count down timer */
 		/* nts = ts + ld + (TLV - now)
 		 * ts=old stamp, ld=time that passed before passing through -1
